#ifndef cglsReg_H
#define cglsReg_H

#include "float2DReg.h"
#include "cgls.h"
#include "oper.h"
#include "oper2D.h"
#include "oper1D.h"

using namespace SEP;

// CGLS solver of min{norm2(Lm - d) + norm2(eps*Dm - dat2)}
class cglsReg : public cgls{

public:
    // Inheriting all constructors from CGLS
    using cgls::cgls;

    // run the solver for 1D problem
    void run(const oper1D * L, const oper1D * D, const float eps, std::shared_ptr<float1DReg> mod, const std::shared_ptr<float1DReg> dat, std::shared_ptr<float1DReg> dat2 = nullptr);

    // run the solver for 2D problem
    void run(const oper2D * L, const oper2D * D, const float eps, std::shared_ptr<float2DReg> mod, const std::shared_ptr<float2DReg> dat, std::shared_ptr<float2DReg> dat2 = nullptr);

    // test the solver for a full rank system Lm = d, eps << or >>, D=Id, dat2 = 0 with 1D vectors
    void test();
    
};

#endif