#include <math.h>
#include <iostream>
#include "propagate_1d.h"
#include "Trace.h"
#include "functions.h"

// 1D wavefield propagation using the 1D scalar wave equation

void propagate_1d(vector <TYPE>* mod, vector <TYPE>* src, unsigned int x_src){
    unsigned int Nx = mod->size();
    unsigned int tmax = src->size();
    string PATH = "/Users/nmbader/Desktop/PhD/Cpp/PEF";
    TYPE dx = 20.0, dt = 0.01;
    Trace tr;
    tr.set_si(dx);
    TYPE s_x;
    TYPE * p_mod = mod->data();
    TYPE * p_src = src->data();
    vector <TYPE> * ut_1 = new vector <TYPE>(Nx);
    vector <TYPE> * ut = new vector <TYPE>(Nx);
    for (int it=0; it<tmax; it++){
        vector <TYPE> * ut1 = new vector <TYPE>(Nx);
        TYPE * p_ut = ut->data();
        TYPE * p_ut_1 = ut_1->data();    
        TYPE * p_ut1 = ut1->data();
        p_ut1[0] = 0;
        //p_ut1[0] = 2*p_ut[0] - p_ut_1[0] + 
        //dt*dt*p_mod[0]*p_mod[0]*(p_ut[1]-2*p_ut[0]-p_ut[1])/(dx*dx);
        for (int ix=1; ix<x_src; ix++){
            s_x = 0.5*(1/p_mod[ix] + 1/p_mod[ix]);
            p_ut1[ix] = 2*p_ut[ix] - p_ut_1[ix] + 
            dt*dt/(s_x*s_x)*(p_ut[ix-1]-2*p_ut[ix]+p_ut[ix+1])/(dx*dx);
        }
        s_x = 0.5*(1/p_mod[x_src] + 1/p_mod[x_src]);
        p_ut1[x_src] = 2*p_ut[x_src] - p_ut_1[x_src] + 
        dt*dt/(s_x*s_x)*(p_ut[x_src-1]-2*p_ut[x_src]+p_ut[x_src+1])/(dx*dx) 
        + p_src[it];
        for (int ix=x_src+1; ix<Nx-1; ix++){
            s_x = 0.5*(1/p_mod[ix] + 1/p_mod[ix]);
            p_ut1[ix] = 2*p_ut[ix] - p_ut_1[ix] + 
            dt*dt/(s_x*s_x)*(p_ut[ix-1]-2*p_ut[ix]+p_ut[ix+1])/(dx*dx);
        }
        //p_ut1[Nx-1] = 2*p_ut[Nx-1] - p_ut_1[Nx-1] + 
        //dt*dt*p_mod[Nx-1]*p_mod[Nx-1]*(-p_ut[Nx-2]-2*p_ut[Nx-1]+p_ut[Nx-2])/(dx*dx);
        p_ut1[Nx-1] = 0;

        tr.set_vector(ut);
        tr.save(PATH+"/data/wave_1d"+to_string(it)+".txt");
        saveplot(PATH+"/data/wave_1d"+to_string(it)+".txt","set xrange [0:4000]\n set yrange [-1:1]\n");

        //delete ut_1;
        ut_1 = ut;
        ut = ut1;
    }
    tr.set_vector(ut);
    tr.save(PATH+"/data/wave_1d"+to_string(tmax)+".txt");
    saveplot(PATH+"/data/wave_1d"+to_string(tmax)+".txt","set xrange [0:4000]\n set yrange [-1:1]\n");
     
    system("ffmpeg -r 25 -i ../data/wave_1d%d.png ../data/wave_1d.mp4");
    system("rm ~/Desktop/PhD/Cpp/PEF/data/wave_1d*.txt");
    system("rm ~/Desktop/PhD/Cpp/PEF/data/wave_1d*.png");
    //delete ut_1;
    //delete ut;
}